/*test child-num attribute X-NODEREF*/
function getChildNum returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-noderef hChild.
   create x-noderef hTemp.
   create x-noderef hRoot.

   hRoot:child-num no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
         then message "Unexpected error child-num: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node(hRoot,"root","element").

   if hRoot:child-num <> 1 then message "Unexpected error child-num".

   hRoot:child-num = 123 no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4052
            then message "Unexpected error child-num: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node(hTemp,"hTemp","element").
   hDoc:create-node(hChild,"","text").
   hDoc:append-child(hRoot).
   hRoot:append-child(hChild).
   hRoot:append-child(hTemp).

   if hRoot:child-num <> 1 or hTemp:child-num <> 2 or hDoc:child-num <> ? then message "Unexpected error child-num".
   if hDoc:child-num <> ? then message "Unexpected error child-num: Document should return unknown value".
   return 0.
end.

getChildNum(-1).