/*test memptr-to-node-value and node-value-to-memptr attribute X-NODEREF*/
function memptrNodeValue returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var hTemp2 as handle.

   def var m1 as memptr no-undo.
   def var m2 as memptr no-undo.
   def var m3 as memptr no-undo.
   def var i  as int no-undo.

   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-noderef hChild.
   create x-noderef hTemp.
   create x-noderef hTemp2.
   create x-noderef hRoot.

   hRoot:node-value-to-memptr(m1) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
         then message "Unexpected error node-value-to-memptr: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:memptr-to-node-value(m1) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
         then message "Unexpected error memptr-to-node-value: " error-status:get-number(1) " " error-status:get-message(1).
   hDoc:create-node(hRoot,"root","element").

   m3 = ?.
   hRoot:node-value-to-memptr(m3) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
      then message "Unexpected error node-value-to-memptr: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node(hChild, "a", "attribute").
   hDoc:append-child(hRoot).
   hRoot:set-attribute-node(hChild).

   set-size(m1) = 10001.
   set-size(m2) = 101.
   do i=1 to 10000:
      put-byte(m1, i) = i.
   end.

   hChild:memptr-to-node-value(m1).

   hChild:node-value-to-memptr(m2).

   if m1 <> m2 then message "Unexpected error memptr-to-node-value and node-value-to-memptr".

   return 0.
end.

memptrNodeValue(-1).