/*test set-attribute attribute X-NODEREF*/
function setAttribute returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-noderef hRoot.
   create x-noderef hChild.

   hRoot:set-attribute("a", "c") no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
      then message "Unexpected error set-attribute: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild,"","text").
   hDoc:append-child(hRoot).
   hRoot:append-child(hChild).
   c = ?.
   hRoot:set-attribute("a", c) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
                              then message "Unexpected error set-attribute: " error-status:get-number(1) " " error-status:get-message(1).
   hRoot:set-attribute(c, "a") no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
         then message "Unexpected error set-attribute: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:set-attribute(c, c) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
         then message "Unexpected error set-attribute: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:set-attribute("&", "asd") no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9082
         then message "Unexpected error set-attribute: " error-status:get-number(1) " " error-status:get-message(1).

   hChild:set-attribute("test", "asd") no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9082
         then message "Unexpected error set-attribute: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:set-attribute("test", "data").
   c = hRoot:get-attribute("test").
   if c <> "data" then message "Unexpected error set-attribute".

   return 0.
end.
setAttribute(-1).