/*test num-children attribute X-NODEREF*/
function getNumChildren returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-noderef hRoot.
   create x-noderef hChild.
   create x-noderef hTemp.

   hRoot:num-children no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
         then message "Unexpected error num-children: " error-status:get-number(1) " " error-status:get-message(1).


   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hTemp,"hTemp","element").
   hDoc:create-node(hChild,"","text").
   hDoc:append-child(hRoot).
   hRoot:append-child(hChild).
   hRoot:append-child(hTemp).

   if hRoot:num-children <> 2 or hDoc:num-children <> 1 or hChild:num-children <> 0 then message "Unexpected error num-children".

   hRoot:num-children = 2 no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4052
            then message "Unexpected error num-children: " error-status:get-number(1) " " error-status:get-message(1).

   return 0.
end.

getNumChildren(-1).
