/*test get-parent attribute X-NODEREF*/
function getParent returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hWork as handle.
   def var hTemp as handle.
   def var res as logical init false.
   def var l as logical.
   def var c as character.
   create x-document hDoc.
   create x-noderef hRoot.

   create x-noderef hTemp.
   create x-noderef hChild.

   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild,"child","element").
   hDoc:append-child(hRoot).

   hChild:get-parent(hWork) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
                        then message "Unexpected error get-parent: " error-status:get-number(1) " " error-status:get-message(1).
   create x-noderef hWork.

   hWork:get-parent(hTemp) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
                        then message "Unexpected error get-parent: " error-status:get-number(1) " " error-status:get-message(1).

   hChild:get-parent(hWork).
   hWork:subtype no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
                     then message "Unexpected error get-parent: " error-status:get-number(1) " " error-status:get-message(1).
   hRoot:append-child(hChild).
   hChild:get-parent(hWork).

   hWork:subtype.

   if hWork:name <> hRoot:name then message "error get-parent".

   hRoot:remove-child(hChild).

   hChild:get-parent(hWork). /*hWork should be unknown */

   hWork:subtype no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
                     then message "Unexpected error get-parent: " error-status:get-number(1) " " error-status:get-message(1).

   return 0.
end.

getParent(-1).