/*test namespace-prefix attribute X-NODEREF*/
function namespacePrefixAndLocalNameAndURI returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-noderef hChild.
   create x-noderef hTemp.
   create x-noderef hRoot.



   hRoot:namespace-prefix no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
                  then message "Unexpected error namespace-prefix: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:namespace-uri no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
                  then message "Unexpected error namespace-uri: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:local-name no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
                  then message "Unexpected error local-name: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node(hRoot,"root","element").

   if hRoot:namespace-uri <> "" then message "error hRoot:namespace-uri".
   if hRoot:local-name <> "" then message "error local-name".
   if hRoot:namespace-prefix <> "" then message "error namespace-prefix".

   hRoot:namespace-prefix = "tt" no-error.

   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(2) eq 9082 and not error-status:get-number(1) eq 3131
                     then message "Unexpected error node-value: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node-namespace(hRoot, "aa", "tt", "element").
   hRoot:namespace-prefix = "" no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(2) eq 9082 and not error-status:get-number(1) eq 3131
                        then message "Unexpected error node-value: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:namespace-prefix = "ttt".
   if hRoot:namespace-prefix <> "ttt" or hRoot:name <> "ttt:tt" then message "error namespace-prefix".
   if hRoot:local-name <> "tt" then message "error local-name".
   if hRoot:namespace-uri <> "aa" then message "error hRoot:namespace-uri".

   hRoot:namespace-prefix = "&" no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(2) eq 9082 and not error-status:get-number(1) eq 3131
                     then message "Unexpected error node-value: " error-status:get-number(1) " " error-status:get-message(1).

   c = ?.
   hRoot:namespace-prefix = c no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4083
                  then message "Unexpected error namespace-prefix: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:namespace-uri = c no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4083
                  then message "Unexpected error namespace-uri: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:namespace-uri = "asd" no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4052
                  then message "Unexpected error namespace-uri: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:local-name = c no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4083
                  then message "Unexpected error local-name: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:local-name = "asd" no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4052
                  then message "Unexpected error local-name: " error-status:get-number(1) " " error-status:get-message(1).
   return 0.
end.

namespacePrefixAndLocalNameAndURI(-1).