/*test public-id attribute*/
function getPublicId returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hNode1 as handle.
   def var res as logical init false.
   def var c as character.
   def var unk as character.
   def var namespaceURI as character.
   def var rootNodeName as character.
   def var systemId as character.
   def var publicId as character.

   namespaceURI = "http://www.w3.org/1999/xhtml".
   rootNodeName = "h:html".
   systemId = "http://www.w3.org/TR/html4/strict.dtd".
   publicId = "-//W3C//DTD HTML 4.01//EN".


   create x-document hDoc.

   c = "asd".
   c = hDoc:public-id.
   if not c eq ? then "Unexpected error1: public-id doesn't equals ? string".
   c = ?.
   hDoc:public-id = c no-error.
   if error-status:error or not error-status:get-number(1) eq 4083
            then message "Unexpected error2: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:public-id = "test test" no-error.
   if error-status:error or not error-status:get-number(1) eq 4052
      then message "Unexpected error3: " error-status:get-number(1) " " error-status:get-message(1).


   hDoc:initialize-document-type(namespaceURI, rootNodeName, publicId, systemId).
   if not hDoc:public-id eq publicId
            then message "Unexpected error public-id4: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:initialize-document-type(namespaceURI, rootNodeName, ?, systemId).
   if not hDoc:public-id eq ""
               then message "Unexpected error public-id5: " error-status:get-number(1) " " error-status:get-message(1).

   return 0.
end.

getPublicId(-1).