/*test remove-attribute X-NODEREF*/
function removeAttribute returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var hTemp2 as handle.

   def var i  as int no-undo.

   def var res as logical init false.
   def var c as character init false.
   c = ?.
   create x-document hDoc.
   create x-noderef hChild.
   create x-noderef hTemp.
   create x-noderef hTemp2.
   create x-noderef hRoot.

   hRoot:remove-attribute(c, c) no-error.
   message "1: " error-status:num-messages.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
         then message "Unexpected error remove-attribute1: " error-status:get-number(1) " " error-status:get-message(1).
   message "2: " error-status:num-messages.
   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild, "a", "attribute").
   hDoc:create-node(hTemp, ?, "text").
   hDoc:append-child(hRoot).
   hRoot:set-attribute-node(hChild).
   hChild:node-value="test".
   message "3: " error-status:num-messages.
   hRoot:remove-attribute(c, c) no-error.
   message "4: " error-status:num-messages.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
      then message "Unexpected error remove-attribute2: " error-status:get-number(1) " " error-status:get-message(1).
   message "5: " error-status:num-messages.

   hTemp2:remove-attribute("a", c) no-error.
   message "6: " error-status:num-messages.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
      then message "Unexpected error remove-attribute3: " error-status:get-number(1) " " error-status:get-message(1).
   message "7: " error-status:num-messages.

   hRoot:remove-attribute("aa", c).
   if hRoot:get-attribute("a") <> "test" then message "Unexpected error remove-attribute4".
   hRoot:remove-attribute("a", c).
   if hRoot:get-attribute("a") <> "" then message "Unexpected error remove-attribute5".

   hTemp:remove-attribute("a", c) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9082
         then message "Unexpected error remove-attribute6: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node-namespace(hTemp, "aaa", "ttt:el", "element").
   hDoc:create-node-namespace(hTemp2, "aaa", "ttt:at", "attribute").
   hTemp2:node-value="test".
   hTemp:set-attribute-node(hTemp2).

   hTemp:remove-attribute("ttt:at", "aaa") no-error.
   if hRoot:get-attribute("ttt:at") <> "" then message "Unexpected error remove-attribute7".

   return 0.
end.

removeAttribute(-1).