
/*test replace-child attribute X-NODEREF*/
function replaceChild returns int (err-num as int):
   def var hDoc as handle.
   def var hDoc2 as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var hTemp2 as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-document hDoc2.
   create x-noderef hChild.
   create x-noderef hTemp.

   hTemp:replace-child(hChild, hDoc) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
              then message "Unexpected error replace-child: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:replace-child(hRoot, hTemp2) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
         then message "Unexpected error replace-child: " error-status:get-number(1) " " error-status:get-message(1).

   create x-noderef hTemp2.

   hDoc:replace-child(hRoot, hChild) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
      then message "Unexpected error replace-child: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:replace-child(hChild, hRoot) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
              then message "Unexpected error replace-child: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node(hChild,"root1","element").

   hDoc:replace-child(hChild, hRoot) no-error.

   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
              then message "Unexpected error replace-child: " error-status:get-number(1) " " error-status:get-message(1).

   create x-noderef hRoot.
   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild,"root1","element").
   hDoc:create-node(hTemp,"temp","element").

   hDoc:append-child(hRoot).

   hDoc:replace-child(hRoot, hChild) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9082
              then message "Unexpected error replace-child: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:replace-child(hChild, hRoot).

   hDoc:get-child(hTemp2, 1).
   if hTemp2:name <> hChild:name then message "Unexpected error replace-child".

   hDoc:replace-child(hRoot, hChild).
   hDoc:get-child(hTemp2, 1).

   if hTemp2:name <> hRoot:name then message "Unexpected error replace-child".

   hDoc2:create-node(hTemp,"temp","element").
   hDoc:replace-child(hTemp, hRoot) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9082
              then message "Unexpected error replace-child: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node(hTemp,"temp","element").
   hRoot:append-child(hChild).
   hChild:append-child(hTemp).

   hChild:replace-child(hRoot, hTemp) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9082
              then message "Unexpected error replace-child: " error-status:get-number(1) " " error-status:get-message(1).

   return 0.
end.

replaceChild(-1).